if select(6, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING" then return end

local RACE_TEX_COORDS = {
	["Human_2"]     = {0, 0.125, 0, 0.25},
	["Dwarf_2"]     = {0.125, 0.25, 0, 0.25},
	["Gnome_2"]     = {0.25, 0.375, 0, 0.25},
	["NightElf_2"] = {0.375, 0.5, 0, 0.25},
	["Draenei_2"]   = {0.5, 0.625, 0, 0.25},
	["Tauren_2"]    = {0, 0.125, 0.25, 0.5},
	["Scourge_2"]    = {0.125, 0.25, 0.25, 0.5},
	["Troll_2"]     = {0.25, 0.375, 0.25, 0.5},
	["Orc_2"]       = {0.375, 0.5, 0.25, 0.5},
	["BloodElf_2"] = {0.5, 0.625, 0.25, 0.5},
	["Human_3"]     = {0, 0.125, 0.5, 0.75},
	["Dwarf_3"]     = {0.125, 0.25, 0.5, 0.75},
	["Gnome_3"]     = {0.25, 0.375, 0.5, 0.75},
	["NightElf_3"] = {0.375, 0.5, 0.5, 0.75},
	["Draenei_3"]   = {0.5, 0.625, 0.5, 0.75},
	["Tauren_3"]    = {0, 0.125, 0.75, 1},
	["Scourge_3"]    = {0.125, 0.25, 0.75, 1},
	["Troll_3"]     = {0.25, 0.375, 0.75, 1},
	["Orc_3"]       = {0.375, 0.5, 0.75, 1},
	["BloodElf_3"] = {0.5, 0.625, 0.75, 1},
}

local CREATURE_ICONS = {
    ["Beast"]          = "Interface\\ICONS\\Ability_Tracking",
    ["Critter"]        = "Interface\\ICONS\\ABILITY_SEAL",
    ["Demon"]          = "Interface\\ICONS\\Spell_Shadow_SummonFelHunter",
    ["Dragonkin"]      = "Interface\\ICONS\\INV_Misc_Head_Dragon_01",
    ["Giant"]          = "Interface\\ICONS\\Ability_Racial_Avatar",
    ["Humanoid"]       = "Interface\\ICONS\\Spell_Holy_PrayerOfHealing",
    ["Elemental"]      = "Interface\\ICONS\\Spell_Frost_SummonWaterElemental",
    ["Mechanical"]     = "Interface\\ICONS\\INV_Misc_Gear_01",
    ["Undead"]         = "Interface\\ICONS\\Spell_Shadow_DarkSummoning",
    ["Totem"]          = "Interface\\Icons\\Spell_Totem_WardOfDraining",
    ["Non-combat Pet"] = "Interface\\Icons\\INV_Gizmo_GoblingTonkController",
--    ["Not specified"]  = "Interface\\ICONS\\INV_Misc_QuestionMark",
}

local PitBull4 = _G.PitBull4
if not PitBull4 then
	error("PitBull4_RaceIcon requires PitBull4")
end

local L = PitBull4.L

local PitBull4_RaceIcon = PitBull4:NewModule("RaceIcon", "AceEvent-3.0")

PitBull4_RaceIcon:SetModuleType("indicator")
PitBull4_RaceIcon:SetName(L["Race icon"])
PitBull4_RaceIcon:SetDescription(L["Shows an race or creature type icon on the unit frame."])
PitBull4_RaceIcon:SetDefaults({
	attach_to = "root",
	location = "edge_bottom_left",
	position = 1,
})

function PitBull4_RaceIcon:GetTexture(frame)
	local _, race = UnitRace(frame.unit)
	if race then
		return [[Interface\Glues\CharacterCreate\UI-CharacterCreate-Races]]
	else
		return CREATURE_ICONS[UnitCreatureType(frame.unit)]
	end
end

function PitBull4_RaceIcon:GetExampleTexture(frame)
	if random(2) == 1 then
		return [[Interface\Glues\CharacterCreate\UI-CharacterCreate-Races]]
	else
		local SEED_CREATURE = {
			"Beast",
			"Critter",
			"Demon",
			"Dragonkin",
			"Giant",
			"Humanoid",
			"Elemental",
			"Mechanical",
			"Undead",
			"Totem",
			"Non-combat Pet",
		}
		return CREATURE_ICONS[SEED_CREATURE[random(11)]]
	end
end

function PitBull4_RaceIcon:GetTexCoord(frame, texture)
	local _, race = UnitRace(frame.unit)
	if race then
		local race_sex = RACE_TEX_COORDS[race .. "_" .. UnitSex(frame.unit)]
		return race_sex[1], race_sex[2], race_sex[3], race_sex[4]
	elseif UnitCreatureType(frame.unit) then
		return 0, 1, 0, 1
	end
end

function PitBull4_RaceIcon:GetExampleTexCoord(frame, texture)
	if texture == [[Interface\Glues\CharacterCreate\UI-CharacterCreate-Races]] then
		local SEED_RACE = {
			"Human",
			"Dwarf",
			"Gnome",
			"NightElf",
			"Draenei",
			"Tauren",
			"Scourge",
			"Troll",
			"Orc",
			"BloodElf",
		}
		local race_sex_seed = RACE_TEX_COORDS[SEED_RACE[random(10)] .. "_" .. random(2,3)]
		return race_sex_seed[1], race_sex_seed[2], race_sex_seed[3], race_sex_seed[4]
	else
		return 0, 1, 0, 1
	end
end
